#!/usr/bin/env python
# -*- coding: utf-8 -*-

# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
# ------------
#| Change Log |
# ------------
# Rel 0.1: Initial relase http://gimpchat.com/viewtopic.php?f=9&t=11524
# Rel 0.2: change procedure Gmic to Gmic-QT
# Rel 0.3: fixing some bugs
# Rel 0.4: separation of Gmic filters, add frame.
# Rel 0.5: change name in menu (old name: File/Create/Logos/G'mic Logo..), add option: use for Logo or Image, use color or patterns, Random, save parameters as layer.

from gimpfu import *
import os
import random

# the color parameter in Gmic filters requires only three parameters (r, g, b) - Gimp takes four parameters (r, g, b, a)
def gmic_rgba_to_rgb(rgba_color):

	r = rgba_color[0]
	g = rgba_color[1]
	b = rgba_color[2]

	# write rgb in correct syntax
	rgb_color = "{0},{1},{2}".format(r,g,b)
	return rgb_color
	
def gmic_hex_to_rgb(hex_color):
    hex_color = hex_color.replace(" ", "").replace("#", "")
    # 3-digits hex color
    if len(hex_color) == 3:
        r = hex_color[0] * 2
        g = hex_color[1] * 2
        b = hex_color[2] * 2
    # 6-digits hex color
    elif len(hex_color) == 6:
        r = hex_color[0:2]
        g = hex_color[2:4]
        b = hex_color[4:6]
    else:
        return "length error"
    # convert hex to decimal
    r = int(r, 16)
    g = int(g, 16)
    b = int(b, 16)

    # check if in range 0~255
    assert 0 <= r <= 255
    assert 0 <= g <= 255
    assert 0 <= b <= 255
    # write rgb in correct syntax
    rgb_color = "{0},{1},{2}".format(r, g, b)
    return rgb_color
	
def python_fu_gmic_exercise(image, layer, options, text, margin, font, direction, just, letter_spacing, line_spacing, font_size,fill_t,text_color,text_pattern,fill_b,background_color,b_pattern,background_opacity, gmic1,gmic2, frame, frame_color, flatten):
	
	gmic_command=[
	" RANDOM ", 	
	" 1. Clouds ",
	" 2. Chalk It Up ",
	" 3. Colored Engraving ", 
	" 4. Colored Outlines ", 
	" 5. Colorize Lineart [ auto-fill ] ",
	" 6. Contours Arrondis ",
	" 7. Contours Colores ",
	" 8. Contours Gros Pixels ",			
	" 9. Couleurs Metalliques ",
	" 10. Couleurs Rayees ",		
	"11. Cracks ",
	"12. Diffusion Tensors ",
	"13. Doodle ",
	"14. Dorure Gilding ",			
	"15. Dream Smoothing ",
	"16. DropShadow 3D ",
	"17. Edges on Fire ",
	"18. Engrave ",
	"19. Fx Sketchbw Modifie ",			
	"20. Gradient Norm ",
	"21. Gradient RGB ",
	"22. Granular Texture ",		
	"23. Graphic Boost ",		
	"24. Grid [ triangular ] ",
	"25. Hallucinogen ",		
	"26. Hard Sketch ",
	"27. Hough Sketch ",
	"28. Impressions ",
	"29. Isophotes Vers Aquarelle ",
	"30. Lava ",
	"31. Light Patch ",
	"32. Lylejk's Stencil ",
	"33. Marble ",
	"34. Metallic Stencils ",
	"35. Morphological ",	
	"36. Paint Daub ",
	"37. Pen Drawing ",
	"38. Plasmicv2 ",
	"39. Polygonize [ Energy ] ",
	"40. Random Plasma ",
	"41. Relief Light ",
	"42. Ripple ",
	"43. Rodilius ",		
	"44. Sketch ",	
	"45. Stained Glass ",
	"46. Stencil ",
	"47. Strip ",
	"48. Warp by Intensity ",
	"49. Whirls ",
	"50. Wind ",]
	frame_command =[
	" RANDOM ", 
	" DON'T USE ",
	" Frame [Blur] ",
	" Frame [Fuzzy] ",
	" Frame [Mirror] ",
	" Frame [Painting] ", 
	" Frame [Painting At06A_2017] ",
	" Frame [Regular] ",
	" Frame [Round] ",
	" Old Photograph ",
	" Polaroid ",
	" Vignette "]		
	if options==0 or options==2:	# Text Logo
		
		image = gimp.Image(font_size, font_size, RGB)

		# create layer with text and add it to the image: image, drawable, x, y, text, border, antialias, size, size_type, fontname
		text_layer = pdb.gimp_text_fontname(image, None, 0, 0, text, 0, 1, font_size, PIXELS, font)

		# justification:
		pdb.gimp_text_layer_set_base_direction (text_layer, direction)
		pdb.gimp_text_layer_set_justification (text_layer, just)
		pdb.gimp_text_layer_set_letter_spacing(text_layer, letter_spacing)
		pdb.gimp_text_layer_set_line_spacing(text_layer, line_spacing)
		
		if fill_t==0:
			 pdb.gimp_text_layer_set_color(text_layer, text_color)
			 
		pdb.gimp_image_set_active_layer(image,text_layer)		
		pdb.plug_in_autocrop_layer(image, text_layer)
		pdb.gimp_image_resize_to_layers(image)
		
		if fill_t==1:
			pdb.gimp_image_select_item(image,0,text_layer)
			pdb.gimp_context_set_pattern(text_pattern)
			pdb.gimp_edit_fill(text_layer,4)
			pdb.gimp_selection_none(image)
			
		wi = pdb.gimp_image_width(image)
		hi = pdb.gimp_image_height(image)
		
		new_width = wi + 2*margin
		new_height = hi + 2*margin
		
		wh = pdb.gimp_drawable_width(text_layer)
		hh = pdb.gimp_drawable_height(text_layer)
		centerx=wi/2
		centery=hi/2
		adw=wh/2
		adh=hh/2
		sw=centerx - adw
		sh=centery - adh		
		pdb.gimp_layer_set_offsets(text_layer, sw, sh)
		pdb.gimp_image_resize(image,new_width,new_height,margin, margin)
		pdb.gimp_layer_resize_to_image_size(text_layer)
			
		# create layer: image, width, height, type, name, opacity, mode
		layer = gimp.Layer(image, "background", image.width, image.height, RGBA_IMAGE, background_opacity, 0)

		# append layer to the image
		image.add_layer(layer, 1)

		# fill layer with color
	
		if fill_b==0:
			gimp.set_background(background_color)
			pdb.gimp_edit_fill(layer,1)
			layer = image.merge_visible_layers(CLIP_TO_IMAGE)
		if fill_b==1:
			pdb.gimp_image_select_item(image,0,layer)
			pdb.gimp_context_set_pattern(b_pattern)
			pdb.gimp_edit_fill(layer,4) 		
			#layer.fill(FILL_BACKGROUND)
			layer = image.merge_visible_layers(CLIP_TO_IMAGE)	
			
		
	if options==1 or options==3:	# Image	
		active_layer = pdb.gimp_image_get_active_layer(image)
		w = pdb.gimp_drawable_width(active_layer)
		h = pdb.gimp_drawable_height(active_layer)

		image = pdb.gimp_image_new(w, h, 0)

		display = pdb.gimp_display_new(image)
		#pdb.gimp_image_undo_group_start(new_image)
		active_layer = pdb.gimp_layer_new_from_drawable(layer, image)
		pdb.gimp_image_insert_layer(image, active_layer, None, 0)	
		active_layer.name = layer.name
		layer = active_layer
		pdb.gimp_displays_flush()
		#pdb.gimp_image_select_item(image, 2, layer)

#pdb.plug_in_gmic_qt(image, drawable, input, output, command)
#Input layers mode, when non-interactive (0=none, 1=active, 2=all, 3=active & below, 4=active & above,5=all visibles, 6=all invisibles, 7=all visibles (decr.), 8=all invisibles (decr.), 9=all (decr.))
#Output mode, when non-interactive (0=in place,1=new layers,2=new active layers,3=new image)
	if gmic1==0:	# Logo Image Random
		gmic1 = random.randrange(1,51)

		
	if gmic2==0:	# Logo Image Random
		gmic2 = random.randrange(1,51)
		
	if frame==0:		
		frame = random.randrange(2,12)
		#print pdb.gimp_message("C1=" + str(gmic1) + " " + "C2=" + str(gmic2))		

	if gmic1==1:	# 1 Clouds
		x='-jeje_clouds 70,0.5,50,50'
	if gmic2==1:		
		y='-jeje_clouds 70,0.5,50,50'			

	if gmic1==2:	# 2 Chalk It Up
		x='samj_chalkitup 5,2.5,1.5,50,1,5,5,0,0,7,0.8,1.9,7,0'
	if gmic2==2:		
		y='samj_chalkitup 5,2.5,1.5,50,1,5,5,0,0,7,0.8,1.9,7,0'
		
	if gmic1==3:	# 3 Colored Engraving
		x='Engrave_colore 0,0.5,4,0,8,40,0,25,1,2,0,0,0,255,255,255'
	if gmic2==3:		
		y='Engrave_colore 0,0.5,4,0,8,40,0,25,1,2,0,0,0,255,255,255'
		
	if gmic1==4:	# 4 Colored Outlines
		x='samj_Colored_Outlines 0,2,8,0,0,0,0,0,255'
	if gmic2==4:		
		y='samj_Colored_Outlines 0,2,8,0,0,0,0,0,255'
	
	if gmic1==5:	# 5 Colorize lineart[auto-fill]
		x='-fx_autofill_lineart 90,1,8,0,0'
	if gmic2==5:		
		y='-fx_autofill_lineart 90,1,8,0,0'
		
	if gmic1==6:	# 6 Contours Arrondis
		x='samj_Contours_Arrondis 1,3,5,10,0,0'
	if gmic2==6:		
		y='samj_Contours_Arrondis 1,3,5,10,0,0'
		
	if gmic1==7:	# 7 Contours Colores
		x='samj_Contours_Colores 1.1,2,40,0,0'
	if gmic2==7:		
		y='samj_Contours_Colores 1.1,2,40,0,0'
		
	if gmic1==8:	# 8 Contours Gros Pixels
		x='samj_Contours_Gros_Pixels 1,8,0,20,20,16,1.1,0,0,15,0,0,0,1'
	if gmic2==8:		
		y='samj_Contours_Gros_Pixels 1,8,0,20,20,16,1.1,0,0,15,0,0,0,1'

	if gmic1==9:	# 9 Couleurs Metalliques
		x='-Couleurs_Metalliques 0,0,22,0,0,0,0,6,5,20,1,0,0,0,0.3,60,1,1,0'
	if gmic2==9:		
		y='-Couleurs_Metalliques 0,0,22,0,0,0,0,6,5,20,1,0,0,0,0.3,60,1,1,0'
		
	if gmic1==10:	# 10 Couleurs Rayees
		x='samj_Couleurs_Rayees 0,30,0,100,4,4,0,2,0.7,0'
	if gmic2==10:		
		y='samj_Couleurs_Rayees 0,30,0,100,4,4,0,2,0.7,0'
	
	if gmic1==11:	# 11. Cracks
		x='-fx_cracks 30,1,255,255,255,128,0,0,50,50'
	if gmic2==11:		
		y='-fx_cracks 30,1,255,255,255,128,0,0,50,50'

	if gmic1==12:	# 12 Diffusion tensors
		x='-fx_diffusiontensors 10,5,2,1,0.15,1,0,3,0'
	if gmic2==12:		
		y='-fx_diffusiontensors 10,5,2,1,0.15,1,0,3,0'

	if gmic1==13:	# 13 Doodle
		x='-fx_doodle 30,2,2,1.5,2,70,1'
	if gmic2==13:		
		y='-fx_doodle 30,2,2,1.5,2,70,1'
		
	if gmic1==14:	# 14 Dorure Gilding
		x='samj_Dorure 0.4,0.2,0.2,0,1,20,20,0,0.5,0,60,0,0,100,45,18,32,1'
	if gmic2==14:		
		y='samj_Dorure 0.4,0.2,0.2,0,1,20,20,0,0.5,0,60,0,0,100,45,18,32,1'
		
	if gmic1==15:	# 15 Dream Smoothing
		x='-fx_dreamsmooth 3,1,1,0.8,0,0.8,1,24,0'
	if gmic2==15:		
		y='-fx_dreamsmooth 3,1,1,0.8,0,0.8,1,24,0'		
				
	if gmic1==16:	# 16 dropShadow 3D
		x='-fx_drop_shadow3d 2,2,2,2,2,2,2,2,0,0,0,200,0'
	if gmic2==16:		
		y='-fx_drop_shadow3d 2,2,2,2,2,2,2,2,0,0,0,200,0'	
		
	if gmic1==17:	# 17. Edges on Fire
		x='-fx_fire_edges 0.7,0.25,0.5,25,1,20,0,0,50,50'
	if gmic2==17:		
		y='-fx_fire_edges 0.7,0.25,0.5,25,1,20,0,0,50,50'
		
	if gmic1==18:	# 18. Engrave
		x='-fx_engrave 0.5,50,0,8,40,0,0,0,10,1,0,0,0,1,0'
	if gmic2==18:		
		y='-fx_engrave 0.5,50,0,8,40,0,0,0,10,1,0,0,0,1,0'
		
	if gmic1==19:	# 19 Fx Sketchbw Modifie
		x='samj_fx_sketchbw_modifie 3,45,180,30,1.75,0.02,0.5,0.75,0.1,0.7,3,6,0,1,4,0,1234,0,2,100,0.2,1,4,1,0'
	if gmic2==19:		
		y='samj_fx_sketchbw_modifie 3,45,180,30,1.75,0.02,0.5,0.75,0.1,0.7,3,6,0,1,4,0,1234,0,2,100,0.2,1,4,1,0'
	
	if gmic1==20:	# 20. Gradient norm
		x='-fx_gradient_norm 0,0.5,0,100,0,0'
	if gmic2==20:		
		y='-fx_gradient_norm 0,0.5,0,100,0,0'		

	if gmic1==21:	# 21. Gradient RGB
		x='-fx_gradient2rgb 0,0,100,0,0,0'
	if gmic2==21:		
		y='-fx_gradient2rgb 0,0,100,0,0,0'	
	
	if gmic1==22:	#  22 Granular Texture[G'MIC] Granular Texture: samj_Texture_Granuleuse 0.5,20,80,0,0
		x='samj_Texture_Granuleuse 0.5,20,80,0,0,0'
	if gmic2==22:		
		y='samj_Texture_Granuleuse 0.5,20,80,0,0,0'		

	if gmic1==23:	# 23. Graphic boost 
		x='-fx_graphic_boost4 1.25,2,0,0.15,14,0,1,0.5,0.45,2,0,0,0,1,1,1,0.5,0.45,1'
	if gmic2==23:		
		y='-fx_graphic_boost4 1.25,2,0,0.15,14,0,1,0.5,0.45,2,0,0,0,1,1,1,0.5,0.45,1'	

	if gmic1==24:	# 24 Grid [triangular]
		x='-fx_imagegrid_triangular 8,10,0,255,255,255,128'
	if gmic2==24:		
		y=	'-fx_imagegrid_triangular 8,10,0,255,255,255,128'
		
	if gmic1==25:	# 25 Hallucinogen
		x='samj_Hallucinogen 80,2,80,1.5,2,0,0,0,1,80,8'
	if gmic2==25:		
		y='samj_Hallucinogen 80,2,80,1.5,2,0,0,0,1,80,8'			
		
	if gmic1==26:	# 26 Hard Sketch
		x='-fx_hardsketchbw 300,50,1,0.1,20,0,4,0,50,50'
	if gmic2==26:		
		y=	'-fx_hardsketchbw 300,50,1,0.1,20,0,4,0,50,50'
		
	if gmic1==27:	# 27 Hough Sketch
		x='-fx_houghsketchbw 1.25,10,5,80,0.1,4,0,50,50'
	if gmic2==27:		
		y=	'-fx_houghsketchbw 1.25,10,5,80,0.1,4,0,50,50'
		
	if gmic1==28:	# 28 Impressions
		x='samj_Impressions 10,5,5,1,1,0,2,0,1,5,0,5,100,2,4,1,250,1.2'
	if gmic2==28:		
		y='samj_Impressions 10,5,5,1,1,0,2,0,1,5,0,5,100,2,4,1,250,1.2'	
		
	if gmic1==29:	# 29 Isophotes Vers Aquarelle
		x='samj_Isophotes_Vers_Aquarelle 16,0.5,4,0,1,10,1,0,0,0,0,1,10,10,4,3,251,237,206,1'
	if gmic2==29:		
		y='samj_Isophotes_Vers_Aquarelle 16,0.5,4,0,1,10,1,0,0,0,0,1,10,10,4,3,251,237,206,1'	
	
	if gmic1==30:	# 30 Lava
		x='-fx_lava 3,50,0.4,0,0'
	if gmic2==30:		
		y='-fx_lava 3,50,0.4,0,0'	
		
	if gmic1==31:	# 31 Light patch
		x='-fx_light_patch 5,0.7,2.5,0'
	if gmic2==31:		
		y='-fx_light_patch 5,0.7,2.5,0'	
		
	if gmic1==32:	# 32 Lylejk's stencil
		x='-fx_lylejk_stencil 5,10,3,0'
	if gmic2==32:		
		y='-fx_lylejk_stencil 5,10,3,0'	
		
	if gmic1==33:	# 33 Marble
		x='-fx_marble 0.5,0.3,0,0,0.4,0.6,0.6,1.1,0,100'
	if gmic2==33:		
		y='-fx_marble 0.5,0.3,0,0,0.4,0.6,0.6,1.1,0,100'	
		
	if gmic1==34:	# 34 Metallic stencils
		x='fx_metallicstencils 0,0'
	if gmic2==34:		
		y='fx_metallicstencils 0,0'
		
	if gmic1==35:	# 35 Morphological
		x='-fx_morphological 0,0,5,"1,0,1; 0,1,0; 1,0,1",0,0,0,0,0'
	if gmic2==35:		
		y='-fx_morphological 0,0,5,"1,0,1; 0,1,0; 1,0,1",0,0,0,0,0'
		
	if gmic1==36:	# 36 Paint daub
		x='-samj_Barbouillage_Paint_Daub 2,2,100,0.2,1,4,1,1,3'
	if gmic2==36:		
		y='-samj_Barbouillage_Paint_Daub 2,2,100,0.2,1,4,1,1,3'

	if gmic1==37:	# 37 Pen drawing",
		x='-fx_pen_drawing 10,0'
	if gmic2==37:		
		y='-fx_pen_drawing 10,0'

	if gmic1==38:	# "38 Plasmicv2",
		x='-samj_Plasmic_V2 2,4,10,2,0.02,8,0,0,0,0,0,0,255'
	if gmic2==38:		
		y='-samj_Plasmic_V2 2,4,10,2,0.02,8,0,0,0,0,0,0,255'
		
	if gmic1==39:	# "39 Polygonize [Energy]",
		x='-fx_polygonize 300,10,10,10,10,0,0,0,255,0,50,50'
	if gmic2==39:		
		y='-fx_polygonize 300,10,10,10,10,0,0,0,255,0,50,50'
		
	if gmic1==40:	#  40 Random Plasma
		x='samj_Random_Plasma 0,80'
	if gmic2==40:		
		y='samj_Random_Plasma 0,80'		
		
	if gmic1==41:	# 41 Relief light
		x='-fx_light_relief 0.3,0.2,0.2,0,1,0.5,0.5,5,0.5,0,0'
	if gmic2==41:		
		y='-fx_light_relief 0.3,0.2,0.2,0,1,0.5,0.5,5,0.5,0,0'		

	if gmic1==42:	# 42 Ripple
		x='-ripple 10,20,2,0,0'
	if gmic2==42:		
		y='-ripple 10,20,2,0,0'
		
	if gmic1==43:	# 43 Rodilius",
		x='-fx_rodilius 8.2,4,300,5,30,0,1,0,0,0'
	if gmic2==43:		
		y='-fx_rodilius 8.2,4,300,5,30,0,1,0,0,0'
		
	if gmic1==44:	# 44 Sketch
		x='-fx_sketchbw 3,45,180,30,1.75,0.02,0.5,0.75,0.1,0.7,3,6,0,1,4,0,50,50'
	if gmic2==44:		
		y='-fx_sketchbw 3,45,180,30,1.75,0.02,0.5,0.75,0.1,0.7,3,6,0,1,4,0,50,50'	
		
	if gmic1==45:	# 45 Stained glass
		x='-fx_stained_glass 20,0.1,1,1,1,0,0,0,0'
	if gmic2==45:		
		y='-fx_stained_glass 20,0.1,1,1,1,0,0,0,0'
		
	if gmic1==46:	# 46 Stencil",
		x='-fx_stencil 3,0,8,0,2,0,0'
	if gmic2==46:		
		y='-fx_stencil 3,0,8,0,2,0,0'
		
	if gmic1==47:	# 47 Strip"
		x='-jeje_strip 45,50,0,1,0'
	if gmic2==47:		
		y='-jeje_strip 45,50,0,1,0'
		
	if gmic1==48:  	#  48 Warp by intensity
		x='-fx_warp_by_intensity 0.04,0.04,128,128,0,1,3,0,0,50,50'
	if gmic2==48:		
		y='-fx_warp_by_intensity 0.04,0.04,128,128,0,1,3,0,0,50,50'	
		
	if gmic1==49:	# "49 Whirls",
		x='-fx_whirls 7,2,0.2,1.8,11,0'
	if gmic2==49:		
		y='-fx_whirls 7,2,0.2,1.8,11,0'
		
	if gmic1==50:	# 50. Wind",	
		x='-fx_wind 20,0,0.7,20,1,0,0,0'
	if gmic2==50:		
		y='-fx_wind 20,0,0.7,20,1,0,0,0'
		


#pdb.plug_in_gmic_qt(image, drawable, input, output, command)
#Input layers mode, when non-interactive (0=none, 1=active, 2=all, 3=active & below, 4=active & above,5=all visibles, 6=all invisibles, 7=all visibles (decr.), 8=all invisibles (decr.), 9=all (decr.))
#Output mode, when non-interactive (0=in place,1=new layers,2=new active layers,3=new image)

	if options==0 or options==2:  # Text
		gimp.pdb.plug_in_gmic_qt( image, layer, 1, 2, x, run_mode=RUN_NONINTERACTIVE)
		gimp.pdb.plug_in_gmic_qt( image, layer, 1, 2, y, run_mode=RUN_NONINTERACTIVE)
		#pdb.gimp_drawable_edit_fill(layer, 1)
	if options==1 or options==3:	# Image
		
		gimp.pdb.plug_in_gmic_qt( image, layer, 1, 2, x, run_mode=RUN_NONINTERACTIVE)
		gimp.pdb.plug_in_gmic_qt( image, layer, 1, 2, y, run_mode=RUN_NONINTERACTIVE)

	#hex = gmic_hex_to_rgb(frame_color)	
	rgb = gmic_rgba_to_rgb(frame_color)	
	if frame==2:	# " Frame [Blur]
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, '-fx_frame_blur 30,30,0,5,0,0,128,128,128,0,1,' + str(rgb) + ',2,2,1,0,0.50,0.50,0.0',run_mode=RUN_NONINTERACTIVE)
	if frame==3:	# Frame [Fuzzy]
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, 'fx_frame_fuzzy 5,5,10,1,' + str(rgb) + ',255',run_mode=RUN_NONINTERACTIVE)
	if frame==4:	# " " Frame [Mirror]
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, 'fx_frame_mirror 10,10,50,50,0,0,0,0,0.75',run_mode=RUN_NONINTERACTIVE)
	if frame==5:	# " Frame [Painting] "
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, '	fx_frame_painting 10,0.4,6,' + str(rgb) + ',2,400,50,10,1,0.5,123456,0',run_mode=RUN_NONINTERACTIVE)
	if frame==6:	# " Frame [Painting At06A_2017] "
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, 'samj_At06A_2017_frame_painting 10,0.4,6,' + str(rgb) + ',2,400,50,10,1,0.5,123456,35,1,1,1,0,100',run_mode=RUN_NONINTERACTIVE)		
	if frame==7:	# " Frame [Regular]
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, 'fx_frame 0,100,0,100,10,10,' + str(rgb) + ',255,1,255,255,255,255',run_mode=RUN_NONINTERACTIVE)		
	if frame==8:	# " Frame [Round] "
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, 'fx_frame_round 6,20,0.1,0,' + str(rgb) + ',255,0,0.1,3',run_mode=RUN_NONINTERACTIVE)		
	if frame==9:	# " Old Photograph "
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, 'fx_old_photo 200,50,85',run_mode=RUN_NONINTERACTIVE)
	if frame==10:	# " Polaroid "
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, 'fx_polaroid 10,20,0,0,3,1,0,255,100,100',run_mode=RUN_NONINTERACTIVE)	
	if frame==11:	# " Vignette "
		gimp.pdb.plug_in_gmic_qt( image, layer, 4, 1, 'fx_vignette 70,70,95,' + str(rgb) + ',255',run_mode=RUN_NONINTERACTIVE)	

# centered all layers
	for layer in image.layers:		
		wh = pdb.gimp_drawable_width(layer)
		hh = pdb.gimp_drawable_height(layer)
		w = pdb.gimp_image_width(image)
		h = pdb.gimp_image_height(image)
		pdb.gimp_image_set_active_layer(image,layer)
		centerx=w/2
		centery=h/2
		adw=wh/2
		adh=hh/2
		sw=centerx - adw
		sh=centery - adh		
		pdb.gimp_layer_set_offsets(layer, sw, sh)
# -----------------------------------------------------	
		
	if flatten:
	    image.merge_visible_layers(CLIP_TO_IMAGE)
		
### Info
	# Text layer
	p = "  G'MIC Command: " + "\n " + "  GC 1  = " + str(gmic_command[gmic1]) + "\n " + "  GC 2  = " + str(gmic_command[gmic2]) + "\n " + "  Frame = " + str(frame_command[frame])
	# Layer name
	q = str(gmic_command[gmic1]) + " + " + str(gmic_command[gmic2])
	
	info = pdb.gimp_text_fontname(image, None,  0.0, 0.0, p+" ", 0, 1, 20, 1, "Arial")
	pdb.gimp_text_layer_set_color(info, (0,0,0))
	gimp_copy = info.copy(0)
	image.add_layer(gimp_copy, -1)
	pdb.gimp_edit_clear(gimp_copy)
	pdb.gimp_context_set_foreground((255,255,255))
	pdb.gimp_edit_fill(gimp_copy,2)
	pdb.gimp_image_raise_item_to_top(image, gimp_copy)	
	pdb.gimp_image_raise_item_to_top(image, info)
	ren = pdb.gimp_image_merge_down(image, info, 0)
	#ren.name = ren.name.replace("#1","")
	pdb.gimp_item_set_name(ren, q)	
		
	# display results
	if options==0 or options==2:  # Text	
		try:
			gimp.Display(image)
		except:
			pass

register(
	"python_fu_gmic_exercise",
	"Creating logo or artistic image from use G'MIC-QT",
	"Creates logo with specified text and image as 3 command G'mic",
	"MareoQ",
	"MrQ",
	"2020",
	"G'MIC-QT Exercise...",
	"",
	[
		(PF_IMAGE,    "image", "Input image", None),
		(PF_DRAWABLE, "layer", "Input layer", None), 
		(PF_OPTION,   "options", "Use to:", 1, ["Text Logo", "Image"]),
		(PF_TEXT, 	  "text", ("Text:"), "GIMP \nSCRIPTS \nNET "),
		(PF_SPINNER,  "margin", "Add border (px):", 50, (0, 500, 1)),
		(PF_FONT,     "font", "Font:", "Arial"),
		(PF_OPTION,   "Direction", "Direction:", 0, ["From left to right",  "From right to left", "Vertical, right to left (mixed orientation)", "Vertical, right to left (upright orientation)", "Vertical, left to right (mixed orientation)", "Vertical, left to right (upright orientation)\n [* add a space at the end of the line !!!]"]),
		(PF_OPTION,   "just", "Justify:", 2, ["LEFT","RIGHT","CENTER","FILL"]),
		(PF_SPINNER,  "letter_spacing", "Letter Spacing:", 0, (-100, 100, 1, 5, 0, 0)),
		(PF_SPINNER,  "line_spacing", "Line Spacing:", 0, ( -100, 100, 1, 5, 0, 0)),
		(PF_INT,      "font_size", "Font size (px):", 150),
		(PF_OPTION,   "fill_t", "Filling the Text", 0,("Color","Patterns")),		
		(PF_COLOR,    "text_color", "Text color:", (225, 225, 35)),	
		(PF_PATTERN,  "text_pattern", "Text pattern:", "Metal Grit-1"),
		(PF_OPTION,   "fill_b", "Filling the Background:", 0,("Color","Patterns")),
		(PF_COLOR,    "background_color", "Background color:", (50, 25, 225)),
		(PF_PATTERN,  "b_pattern", "Background pattern", "Metal Grit-1"),		
		(PF_SLIDER,   "background_opacity", "Background opacity:", 50, (0, 100, 1)),
		(PF_OPTION,   "gmic1", "G'mic Command 1:", 0, [
		    " RANDOM ",
			" 1. Clouds",
			" 2. Chalk It Up",
			" 3. Colored Engraving", 
			" 4. Colored Outlines", 
			" 5. Colorize Lineart [auto-fill]",
			" 6. Contours Arrondis",
			" 7. Contours Colores",
			" 8. Contours Gros Pixels",			
			" 9. Couleurs Metalliques",
			"10. Couleurs Rayees",		
			"11. Cracks",
			"12. Diffusion Tensors",
			"13. Doodle",
			"14. Dorure Gilding",			
			"15. Dream Smoothing",
			"16. DropShadow 3D",
			"17. Edges on Fire",
			"18. Engrave",
			"19. Fx Sketchbw Modifie",			
			"20. Gradient Norm",
			"21. Gradient RGB",
			"22. Granular Texture",		
			"23. Graphic Boost",		
			"24. Grid [triangular]",
			"25. Hallucinogen",		
			"26. Hard Sketch",
			"27. Hough Sketch",
			"28. Impressions",
			"29. Isophotes Vers Aquarelle",
			"30. Lava",
			"31. Light Patch",
			"32. Lylejk's Stencil",
			"33. Marble",
			"34. Metallic Stencils",
			"35. Morphological",	
			"36. Paint Daub",
			"37. Pen Drawing",
			"38. Plasmicv2",
			"39. Polygonize [Energy]",
			"40. Random Plasma",
			"41. Relief Light",
			"42. Ripple",
			"43. Rodilius",		
			"44. Sketch",	
			"45. Stained Glass",
			"46. Stencil",
			"47. Strip",
			"48. Warp by Intensity",
			"49. Whirls",
			"50. Wind",	
        ]),
		(PF_OPTION,   "gmic2", "G'mic Command 2:", 0, [
		    " RANDOM ",
			" 1. Clouds",
			" 2. Chalk It Up",
			" 3. Colored Engraving", 
			" 4. Colored Outlines", 
			" 5. Colorize Lineart [auto-fill]",
			" 6. Contours Arrondis",
			" 7. Contours Colores",
			" 8. Contours Gros Pixels",			
			" 9. Couleurs Metalliques",
			"10. Couleurs Rayees",		
			"11. Cracks",
			"12. Diffusion Tensors",
			"13. Doodle",
			"14. Dorure Gilding",			
			"15. Dream Smoothing",
			"16. DropShadow 3D",
			"17. Edges on Fire",
			"18. Engrave",
			"19. Fx Sketchbw Modifie",			
			"20. Gradient Norm",
			"21. Gradient RGB",
			"22. Granular Texture",		
			"23. Graphic Boost",		
			"24. Grid [triangular]",
			"25. Hallucinogen",		
			"26. Hard Sketch",
			"27. Hough Sketch",
			"28. Impressions",
			"29. Isophotes Vers Aquarelle",
			"30. Lava",
			"31. Light Patch",
			"32. Lylejk's Stencil",
			"33. Marble",
			"34. Metallic Stencils",
			"35. Morphological",	
			"36. Paint Daub",
			"37. Pen Drawing",
			"38. Plasmicv2",
			"39. Polygonize [Energy]",
			"40. Random Plasma",
			"41. Relief Light",
			"42. Ripple",
			"43. Rodilius",		
			"44. Sketch",	
			"45. Stained Glass",
			"46. Stencil",
			"47. Strip",
			"48. Warp by Intensity",
			"49. Whirls",
			"50. Wind",	
        ]),		
		(PF_OPTION,  "just", "Add frame:", 2, [
			" RANDOM ", 
			" DON'T USE ",
			" Frame [Blur] ",
			" Frame [Fuzzy] ",
			"*** Frame [Mirror] ",
			" Frame [Painting] ", 
			" Frame [Painting At06A_2017]",
			" Frame [Regular] ",
			" Frame [Round] ",
			"*** Old Photograph ",
			"*** Polaroid ",
			" Vignette "]),		
		(PF_COLOR, "frame_color", "Frame color:\n (# = not use color)", (127, 127, 127)),
		#(PF_STRING, "frame_color", "Frame color ( *** = not use color):\n[black=000000 white=ffffff]", "000000")	
		(PF_BOOL,   "flatten",      "Merge layers:", False),
		
	],
	[],
	python_fu_gmic_exercise,
	menu="<Image>/Filters",
	#menu=
	)

main()

